package ru.littlevictor.radio;

import android.content.Context;
import android.preference.PreferenceCategory;
import android.util.AttributeSet;
import android.util.TypedValue;
import android.view.View;
import android.widget.TextView;

public class CustomPreferenceCategory extends PreferenceCategory {

    private int themeBaseColor;
    private int paddingTopPx = 12;
    private int paddingTop;

    public CustomPreferenceCategory(Context context) {
        super(context);
        int theme[] = ThemeChooser.getAppTheme(context);
        if(theme[0] == R.color.color_theme_primary_1) {
            themeBaseColor = context.getResources().getColor(R.color.color_theme_primary_4);
        } else {
            themeBaseColor = context.getResources().getColor(theme[0]);
        }
        paddingTop = (int)TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, paddingTopPx, context.getResources().getDisplayMetrics());
    };

    public CustomPreferenceCategory(Context context, AttributeSet attrs) {
        super(context, attrs);
        int theme[] = ThemeChooser.getAppTheme(context);
        if(theme[0] == R.color.color_theme_primary_1) {
            themeBaseColor = context.getResources().getColor(R.color.color_theme_primary_4);
        } else {
            themeBaseColor = context.getResources().getColor(theme[0]);
        }
        paddingTop = (int)TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, paddingTopPx, context.getResources().getDisplayMetrics());
    };

    public CustomPreferenceCategory(Context context, AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);
        int theme[] = ThemeChooser.getAppTheme(context);
        if(theme[0] == R.color.color_theme_primary_1) {
            themeBaseColor = context.getResources().getColor(R.color.color_theme_primary_4);
        } else {
            themeBaseColor = context.getResources().getColor(theme[0]);
        }
        paddingTop = (int)TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, paddingTopPx, context.getResources().getDisplayMetrics());
    };

    @Override
    protected void onBindView(View view) {
        super.onBindView(view);
        TextView titleView = (TextView) view.findViewById(android.R.id.title);
        titleView.setPadding(titleView.getPaddingLeft(), paddingTop, titleView.getPaddingRight(), titleView.getPaddingBottom());
        titleView.setBackgroundColor(0x00000000);
        titleView.setTextColor(themeBaseColor);
    };
};