package ru.littlevictor.radio;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.Gravity;
import android.widget.Toast;

public class RadioServiceActivity  extends Activity {
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
		Uri inputData = getIntent().getData();
    	String scheme = null;
		String path = null;
		if(inputData == null) {
			int inputAction = getIntent().getIntExtra(getResources().getString(R.string.service_state), -1);
			switch (inputAction) {
			case RadioService.SHORT:
				int position = getIntent().getIntExtra(getResources().getString(R.string.media_position), -1);
				if(position >= 0) {
					startService(new Intent(this, RadioService.class)
					.putExtra("internal", true)
					.putExtra(this.getResources().getString(R.string.service_state), RadioService.SHORT)
					.putExtra(this.getResources().getString(R.string.media_position), position));
				}
				break;
			case RadioService.STOP:
				sendBroadcast(new Intent(getResources().getString(R.string.media_close)));
				break;
			case RadioService.PLAY:
				startService(new Intent(this, RadioService.class)
				.putExtra("internal", true)
				.putExtra(this.getResources().getString(R.string.service_state), RadioService.PLAY));
				break;
			case RadioService.NEXT:
				startService(new Intent(this, RadioService.class)
				.putExtra(this.getResources().getString(R.string.service_state), RadioService.NEXT));
				break;
			case RadioService.PREV:
				startService(new Intent(this, RadioService.class)
				.putExtra(this.getResources().getString(R.string.service_state), RadioService.PREV));
				break;
			}
	        finish();
		} else {
		    try 
		    {
		    	scheme = inputData.getScheme();
				path = inputData.getPath();
		    }
		    catch (Exception e) 
		    {
				showToast(getResources().getString(R.string.invalid_file_path), Toast.LENGTH_LONG);
				finish();
		    }
		    if (scheme == null || path == null) 
		    {
				showToast(getResources().getString(R.string.invalid_file_path), Toast.LENGTH_LONG);
				finish();
		    }
			if(scheme.equalsIgnoreCase("file")) {
				if(!getIntent().hasExtra("internal")) Storage.clearCache(this);
				startService(new Intent(this, RadioService.class)
				.putExtra(getResources().getString(R.string.service_state), RadioService.LOAD)
				.putExtra(getResources().getString(R.string.data_path), path));
				finish();
				startActivity(new Intent(this, RadioMain.class)
                .putExtra("internal", true)
				.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_CLEAR_TASK));
			} else {
				showToast(getResources().getString(R.string.invalid_file_path), Toast.LENGTH_LONG);
				finish();
			};
		};
    };

	// -----------------------------------------------------------------------------
	private void showToast(String message, int length) {
		Toast toast = Toast.makeText(this, message, length);
		toast.setGravity(Gravity.CENTER_HORIZONTAL | Gravity.CENTER_VERTICAL, 0, 0);
		toast.show();
	};
};
